// =======================================================================================
//
//  orbit.h
//
//  Screen Saver Module for BeOS
//
// =======================================================================================

#ifndef _ORBIT_H_
#define _ORBIT_H_

#include <add-ons/screen_saver/ScreenSaver.h>
#include <GLView.h>
#include <glu.h>
#include "orbitconfig.h"
#include "orbitview.h"

//
// COrbitSaver -- the necessary BScreenSaver-derived class
//

class COrbitSaver : public BScreenSaver
{
private:
	COrbitView    *pGLView;
	COrbitConfig  *pConfig;

	bool          bConfigOK;

	OrbitSettings settings;

	bool         bFog;
	int8         nPlanetSize;
	int8         nSatSize;

public:
	COrbitSaver(BMessage *pMsg, image_id img);

	status_t         InitCheck();

	status_t         SaveState(BMessage *pMsg) const;

	virtual void     StartConfig(BView *pView);

	virtual status_t StartSaver(BView *pView, bool bPreview);
	virtual void     StopSaver();

	virtual void     DirectConnected(direct_buffer_info *pInf);
	virtual void     DirectDraw(int32 nFrame);
};

#endif // _ORBIT_H_
