// =======================================================================================
//
//  orbitview.h
//
//  Screen Saver Module for BeOS
//
// =======================================================================================

#ifndef _ORBITVIEW_H_
#define _ORBITVIEW_H_

#include <GLView.h>
#include <glu.h>
#include <vector>
#include "orbitconfig.h"

struct planetdata {
	unsigned int nList; // display list index	
	float        spinaxis[3];
	float        spinamt;
	// used for "bounce" motion
	float        pos[3];
	float        dir[3];
	// used for "orbit" motion
	float        orbitaxis[3];
	float        orbitamt;
};

struct satdata {
	unsigned int nList;  // display list index
	float        color[4];
	float        dist;
	float        orbitaxis[3];
	float        orbitamt;
	float        orbitspd;
};

typedef std::vector<satdata> satdata_vec;

class COrbitView : public BGLView
{
private:
	GLUquadric    *pQuadric;
	OrbitSettings *pSettings;
	planetdata    PlanetData;
	satdata_vec   vSatData;

public:
	COrbitView(BRect rect, char *pcsName, ulong ulMode, ulong ulOpt, OrbitSettings *pSetIn);
	virtual ~COrbitView();

	virtual void AttachedToWindow();
	virtual void DrawFrame();

	void SetupScene(BRect &rect);
	void SetupObjects();
};

#endif // _ORBITVIEW_H_
